#
# spec file for package qemu
#
# Copyright (c) 2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%ifarch %ix86 x86_64
# choice of building all from source or using provided binary x86 blobs
%if 0%{?suse_version} >= 1140
%define build_x86_fw_from_source 1
%else
%define build_x86_fw_from_source 0
%endif
%else
%define build_x86_fw_from_source 0
%endif
%ifarch %ix86 x86_64 ppc ppc64 ppc64le s390x %arm aarch64
%define kvm_available 1
%else
%define kvm_available 0
%endif
%ifarch %ix86 x86_64 s390x
%define legacy_qemu_kvm 1
%else
%define legacy_qemu_kvm 0
%endif
%define noarch_supported 1110

Name:           qemu
Url:            http://www.qemu.org/
Summary:        Universal CPU emulator
License:        BSD-3-Clause and GPL-2.0 and GPL-2.0+ and LGPL-2.1+ and MIT
Group:          System/Emulators/PC
Version:        2.0.0
Release:        0
Source:         %name-2.0.0.tar.bz2
Source1:        80-kvm.rules
Source2:        qemu-ifup
Source3:        kvm_stat
Source4:        qemu-kvm.1.gz
Source5:        60-kvm.rules
Source6:        ksm.service
Source7:        60-kvm.x86.rules
# This patch queue is auto-generated from https://github.com/openSUSE/qemu
Patch0001:      0001-XXX-dont-dump-core-on-sigabort.patch
Patch0002:      0002-XXX-work-around-SA_RESTART-race-wit.patch
Patch0003:      0003-qemu-0.9.0.cvs-binfmt.patch
Patch0004:      0004-qemu-cvs-alsa_bitfield.patch
Patch0005:      0005-qemu-cvs-alsa_ioctl.patch
Patch0006:      0006-qemu-cvs-alsa_mmap.patch
Patch0007:      0007-qemu-cvs-gettimeofday.patch
Patch0008:      0008-qemu-cvs-ioctl_debug.patch
Patch0009:      0009-qemu-cvs-ioctl_nodirection.patch
Patch0010:      0010-block-vmdk-Support-creation-of-SCSI.patch
Patch0011:      0011-linux-user-add-binfmt-wrapper-for-a.patch
Patch0012:      0012-PPC-KVM-Disable-mmu-notifier-check.patch
Patch0013:      0013-linux-user-fix-segfault-deadlock.patch
Patch0014:      0014-linux-user-binfmt-support-host-bina.patch
Patch0015:      0015-linux-user-arm-no-tb_flush-on-reset.patch
Patch0016:      0016-linux-user-Ignore-broken-loop-ioctl.patch
Patch0017:      0017-linux-user-lock-tcg.patch
Patch0018:      0018-linux-user-Run-multi-threaded-code-.patch
Patch0019:      0019-linux-user-lock-tb-flushing-too.patch
Patch0020:      0020-linux-user-Fake-proc-cpuinfo.patch
Patch0021:      0021-linux-user-implement-FS_IOC_GETFLAG.patch
Patch0022:      0022-linux-user-implement-FS_IOC_SETFLAG.patch
Patch0023:      0023-linux-user-XXX-disable-fiemap.patch
Patch0024:      0024-slirp-nooutgoing.patch
Patch0025:      0025-vnc-password-file-and-incoming-conn.patch
Patch0026:      0026-linux-user-add-more-blk-ioctls.patch
Patch0027:      0027-linux-user-use-target_ulong.patch
Patch0028:      0028-block-Add-support-for-DictZip-enabl.patch
Patch0029:      0029-block-Add-tar-container-format.patch
Patch0030:      0030-Legacy-Patch-kvm-qemu-preXX-dictzip.patch
Patch0031:      0031-Legacy-Patch-kvm-qemu-preXX-report-.patch
Patch0032:      0032-console-add-question-mark-escape-op.patch
Patch0033:      0033-Make-char-muxer-more-robust-wrt-sma.patch
Patch0034:      0034-linux-user-lseek-explicitly-cast-no.patch
Patch0035:      0035-virtfs-proxy-helper-Provide-__u64-f.patch
Patch0036:      0036-configure-Enable-PIE-for-ppc-and-pp.patch
Patch0037:      0037-xen_disk-add-discard-support.patch
Patch0038:      0038-tests-Don-t-run-qom-test-twice.patch
Patch0039:      0039-qtest-Assure-that-init_socket-s-lis.patch
Patch0040:      0040-qtest-Add-error-reporting-to-socket.patch
Patch0041:      0041-qtest-Increase-socket-timeout.patch
Patch0042:      0042-qtest-Be-paranoid-about-accept-addr.patch
Patch0043:      0043-arm-translate.c-Fix-smlald-Instruct.patch
Patch0044:      0044-target-arm-A64-fix-unallocated-test.patch
Patch0045:      0045-tcg-ppc64-Support-the-ELFv2-ABI.patch
Patch0046:      0046-vmstate-add-VMS_MUST_EXIST.patch
Patch0047:      0047-vmstate-add-VMSTATE_VALIDATE.patch
Patch0048:      0048-virtio-net-fix-buffer-overflow-on-i.patch
Patch0049:      0049-virtio-net-out-of-bounds-buffer-wri.patch
Patch0050:      0050-virtio-out-of-bounds-buffer-write-o.patch
Patch0051:      0051-ahci-fix-buffer-overrun-on-invalid-.patch
Patch0052:      0052-hpet-fix-buffer-overrun-on-invalid-.patch
Patch0053:      0053-hw-pci-pcie_aer.c-fix-buffer-overru.patch
Patch0054:      0054-pl022-fix-buffer-overun-on-invalid-.patch
Patch0055:      0055-vmstate-fix-buffer-overflow-in-targ.patch
Patch0056:      0056-virtio-avoid-buffer-overrun-on-inco.patch
Patch0057:      0057-virtio-validate-num_sg-when-mapping.patch
Patch0058:      0058-pxa2xx-avoid-buffer-overrun-on-inco.patch
Patch0059:      0059-ssd0323-fix-buffer-overun-on-invali.patch
Patch0060:      0060-tsc210x-fix-buffer-overrun-on-inval.patch
Patch0061:      0061-zaurus-fix-buffer-overrun-on-invali.patch
Patch0062:      0062-virtio-scsi-fix-buffer-overrun-on-i.patch
Patch0063:      0063-vmstate-s-VMSTATE_INT32_LE-VMSTATE_.patch
Patch0064:      0064-usb-sanity-check-setup_index-setup_.patch
Patch0065:      0065-savevm-Ignore-minimum_version_id_ol.patch
Patch0066:      0066-ssi-sd-fix-buffer-overrun-on-invali.patch
Patch0067:      0067-openpic-avoid-buffer-overrun-on-inc.patch
Patch0068:      0068-virtio-net-out-of-bounds-buffer-wri.patch
Patch0069:      0069-virtio-validate-config_len-on-load.patch
Patch0070:      0070-virtio-allow-mapping-up-to-max-queu.patch
# Please do not add patches manually here, run update_git.sh.

# roms/ipxe patches
Patch1000:      ipxe-build-Work-around-bug-in-gcc-4.8.patch
Patch1001:      ipxe-zbin-Fix-size-used-for-memset-in-al.patch
Patch1002:      ipxe-build-Avoid-strict-aliasing-warning.patch
# end roms/ipxe patches

# this is to make lint happy
Source300:      rpmlintrc
Source302:      bridge.conf
Source400:      update_git.sh
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  SDL-devel
BuildRequires:  alsa-devel
BuildRequires:  bluez-devel
%if 0%{?suse_version} >= 1130
BuildRequires:  brlapi-devel
%endif
BuildRequires:  curl-devel
BuildRequires:  cyrus-sasl-devel
%if %{build_x86_fw_from_source}
%if 0%{?suse_version} > 1110
BuildRequires:  iasl
%else
BuildRequires:  pmtools
%endif
%endif
BuildRequires:  e2fsprogs-devel
BuildRequires:  fdupes
BuildRequires:  gcc-c++
BuildRequires:  glib2-devel
%if 0%{?suse_version} >= 1220
BuildRequires:  gtk3-devel
%else
BuildRequires:  gtk2-devel
%endif
BuildRequires:  libaio
BuildRequires:  libaio-devel
BuildRequires:  libattr-devel
BuildRequires:  libcap-devel
BuildRequires:  libcap-ng-devel
%if 0%{?suse_version} >= 1310
# 12.3 and earlier don't ship a compatible libfdt; use the bundled one there
BuildRequires:  libfdt1-devel
%endif
BuildRequires:  libgnutls-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libpcap-devel
BuildRequires:  libpixman-1-0-devel
BuildRequires:  libpng-devel
BuildRequires:  libpulse-devel
BuildRequires:  libtool
%if 0%{?suse_version} > 1310
BuildRequires:  libusb-devel
%endif
BuildRequires:  libvdeplug3-devel
%if 0%{?suse_version} > 1220
BuildRequires:  makeinfo
%endif
BuildRequires:  mozilla-nss-devel
BuildRequires:  ncurses-devel
BuildRequires:  pwdutils
BuildRequires:  python
%if 0%{?suse_version} >= 1210
BuildRequires:  systemd
%{?systemd_requires}
%define with_systemd 1
%endif
%if %{kvm_available}
BuildRequires:  udev
%if %( echo `rpm -q --queryformat %%{version} udev` ) > 190
%define _udevrulesdir /usr/lib/udev/rules.d
%else
%define _udevrulesdir /lib/udev/rules.d
%endif
%endif
%if 0%{?sles_version} != 11
BuildRequires:  usbredir-devel
%endif
%if 0%{?suse_version} >= 1210
%if 0%{?suse_version} >= 1220
BuildRequires:  vte-devel
%else
BuildRequires:  vte2-devel
%endif
%endif
%ifarch x86_64
BuildRequires:  xen-devel
%endif
BuildRequires:  zlib-devel
%if 0%{?suse_version} >= 1140
%ifarch %ix86 x86_64
BuildRequires:  libspice-server-devel
BuildRequires:  spice-protocol-devel
%endif
%endif
Requires:       /usr/sbin/groupadd
Requires:       pwdutils
Requires:       timezone
Recommends:     qemu-tools
Recommends:     qemu-x86
%ifarch ppc ppc64 ppc64le
Recommends:     qemu-ppc
%else
Suggests:       qemu-ppc
%endif
%ifarch s390x
Recommends:     qemu-s390
%else
Suggests:       qemu-s390
%endif
%ifarch %arm aarch64
Recommends:     qemu-arm
%else
Suggests:       qemu-arm
%endif
Suggests:       qemu-extra
Suggests:       qemu-lang
%if 0%{?suse_version} >= 1210
Recommends:     qemu-ksm = %{version}
%endif

%define built_firmware_files {acpi-dsdt.aml bios.bin bios-256k.bin \
q35-acpi-dsdt.aml sgabios.bin vgabios.bin vgabios-cirrus.bin \
vgabios-stdvga.bin vgabios-vmware.bin vgabios-qxl.bin optionrom/linuxboot.bin \
optionrom/multiboot.bin optionrom/kvmvapic.bin pxe-e1000.rom pxe-pcnet.rom \
pxe-ne2k_pci.rom pxe-rtl8139.rom pxe-eepro100.rom pxe-virtio.rom}

%description
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

%package x86
Summary:        Universal CPU emulator -- x86
Group:          System/Emulators/PC
Requires:       qemu = %version
Requires:       qemu-ipxe
Requires:       qemu-seabios
Requires:       qemu-sgabios
Requires:       qemu-vgabios

%description x86
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package provides i386 and x86_64 emulation.

%package ppc
Summary:        Universal CPU emulator -- Power Architecture
Group:          System/Emulators/PC
Requires:       qemu = %version

%description ppc
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package provides ppc and ppc64 emulation.

%package s390
Summary:        Universal CPU emulator -- S/390
Group:          System/Emulators/PC
Requires:       qemu = %version

%description s390
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package provides s390x emulation.

%package arm
Summary:        Universal CPU emulator -- ARM
Group:          System/Emulators/PC
Requires:       qemu = %version

%description arm
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package provides arm emulation.

%package extra
Summary:        Universal CPU emulator -- extra architectures
Group:          System/Emulators/PC
Requires:       qemu = %version

%description extra
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package provides some lesser used emulations, such as moxie and xtensa.

%if %{legacy_qemu_kvm}
%package kvm
Url:            http://www.linux-kvm.org
Summary:        Kernel-based Virtual Machine
Group:          System/Emulators/PC
%ifarch %ix86 x86_64
Requires:       qemu-x86 = %version
%endif
%ifarch s390x
Requires:       qemu-s390 = %version
%endif
Provides:       kvm = %version
Obsoletes:      kvm < %version
Recommends:     python-curses

%description kvm
KVM (Kernel-based Virtual Machine) is virtualization software for Linux.
It is designed to leverage the hardware virtualization features included
with various architectures. QEMU uses KVM for CPU virtualization, while
still providing emulation of other system components. This package is
not required for KVM usage, but rather facilitates its usage with tools
derived from the legacy kvm package.
%endif

%package lang
Summary:        Universal CPU emulator -- Translations
Group:          System/Emulators/PC

%description lang
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package contains translations.

%package tools
Summary:        Universal CPU emulator -- Tools
Group:          System/Emulators/PC
Provides:       qemu:%_libexecdir/qemu-bridge-helper
Obsoletes:      libcacard <= 0.1.2
Provides:       libcacard
PreReq:         permissions

%description tools
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package contains various tools, including a bridge helper.

%package -n libcacard0
Summary:        Common Access Card (CAC) emulation
Group:          System/Emulators/PC

%description -n libcacard0
This emulator is designed to provide emulation of actual smart cards to a
virtual card reader running in a guest virtual machine. The emulated smart
cards can be representations of real smart cards, where the necessary functions
such as signing, card removal/insertion, etc. are mapped to real, physical
cards which are shared with the client machine the emulator is running on, or
the cards could be pure software constructs.

%package -n libcacard-devel
Summary:        Common Access Card (CAC) emulation -- Development files
Group:          Development/Languages/C and C++
Requires:       glib2-devel
Requires:       libcacard0 = %version
Requires:       mozilla-nspr
Requires:       mozilla-nss

%description -n libcacard-devel
This emulator is designed to provide emulation of actual smart cards to a
virtual card reader running in a guest virtual machine. The emulated smart
cards can be representations of real smart cards, where the necessary functions
such as signing, card removal/insertion, etc. are mapped to real, physical
cards which are shared with the client machine the emulator is running on, or
the cards could be pure software constructs.

This sub-package contains development files for the Smartcard library.

%package guest-agent
Summary:        Universal CPU emulator -- Guest agent
Group:          System/Emulators/PC
Provides:       qemu:%_bindir/qemu-ga

%description guest-agent
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package contains the guest agent.

%package seabios
Summary:        X86 BIOS for QEMU
Group:          System/Emulators/PC
Version:        1.7.4
Release:        0
%if 0%{?suse_version} > %{noarch_supported}
BuildArch:      noarch
%endif
Conflicts:      qemu < 1.6.0

%description seabios
SeaBIOS is an open source implementation of a 16bit x86 BIOS. SeaBIOS
is the default BIOS for QEMU.

%package vgabios
Summary:        VGA BIOSes for QEMU
Group:          System/Emulators/PC
Version:        1.7.4
Release:        0
%if 0%{?suse_version} > %{noarch_supported}
BuildArch:      noarch
%endif
Conflicts:      qemu < 1.6.0

%description vgabios
VGABIOS provides the video ROM BIOSes for the following variants of VGA
emulated devices: Std VGA, QXL, Cirrus CLGD 5446 and VMware emulated
video card.

%package sgabios
Summary:        Serial Graphics Adapter BIOS for QEMU
Group:          System/Emulators/PC
Version:        8
Release:        0
%if 0%{?suse_version} > %{noarch_supported}
BuildArch:      noarch
%endif
Conflicts:      qemu < 1.6.0

%description sgabios
The Google Serial Graphics Adapter BIOS or SGABIOS provides a means for legacy
x86 software to communicate with an attached serial console as if a video card
were attached.

%package ipxe
Summary:        PXE ROMs for QEMU NICs
Group:          System/Emulators/PC
Version:        1.0.0
Release:        0
%if 0%{?suse_version} > %{noarch_supported}
BuildArch:      noarch
%endif
Conflicts:      qemu < 1.6.0

%description ipxe
Preboot Execution Environment (PXE) ROM support for various emulated network
adapters available with QEMU.

%if 0%{?with_systemd}
%package ksm
Summary:        Kernel Samepage Merging services
Group:          System/Emulators/PC

%description ksm
Kernel Samepage Merging (KSM) is a memory-saving de-duplication feature,
that merges anonymous (private) pages (not pagecache ones).

This package provides a service file for starting and stopping KSM.
%endif

%prep
%setup -q #-n %name-2.0.0-rc3
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%patch0045 -p1
%patch0046 -p1
%patch0047 -p1
%patch0048 -p1
%patch0049 -p1
%patch0050 -p1
%patch0051 -p1
%patch0052 -p1
%patch0053 -p1
%patch0054 -p1
%patch0055 -p1
%patch0056 -p1
%patch0057 -p1
%patch0058 -p1
%patch0059 -p1
%patch0060 -p1
%patch0061 -p1
%patch0062 -p1
%patch0063 -p1
%patch0064 -p1
%patch0065 -p1
%patch0066 -p1
%patch0067 -p1
%patch0068 -p1
%patch0069 -p1
%patch0070 -p1

%patch1000 -p1
%patch1001 -p1
%patch1002 -p1

%if %{build_x86_fw_from_source}
# as a safeguard, delete the firmware files that we intend to build
for i in %built_firmware_files
do
  rm -f pc-bios/$i
done
%endif

%build
./configure --prefix=%_prefix --sysconfdir=%_sysconfdir \
	--libdir=%_libdir \
	--libexecdir=%_libexecdir \
	--localstatedir=%_localstatedir \
	--extra-cflags="%{optflags}" \
	--disable-strip \
	--enable-system --disable-linux-user \
	--enable-tools --enable-guest-agent \
	--enable-pie \
	--enable-docs \
	--audio-drv-list="pa alsa sdl oss" \
%if 0%{?suse_version} >= 1130
        --enable-brlapi \
%endif
	--enable-cap-ng \
	--enable-curl \
	--enable-curses \
	--enable-gtk \
%if 0%{?suse_version} >= 1220
	--with-gtkabi=3.0 \
%endif
%if %{kvm_available}
	--enable-kvm \
%endif
	--enable-linux-aio \
	--enable-modules \
	--enable-sdl \
	--with-sdlabi=1.2 \
	--enable-smartcard-nss \
%if 0%{?suse_version} >= 1140
%ifarch %ix86 x86_64
	--enable-spice \
%else
	--disable-spice \
%endif
%else
	--disable-spice \
%endif
%if 0%{?suse_version} > 1310
	--enable-libusb \
%endif
%if 0%{?sles_version} != 11
	--enable-usb-redir \
%endif
	--enable-vde \
	--enable-virtfs \
	--enable-virtio-blk-data-plane \
	--enable-vnc-jpeg \
	--enable-vnc-png \
	--enable-vnc-sasl \
	--enable-vnc-tls \
	--enable-vnc-ws \
%ifarch x86_64
	--enable-xen \
%endif

make %{?_smp_mflags} V=1

# Firmware
%if %{build_x86_fw_from_source}
make -C roms bios
make -C roms seavgabios
make -C roms pxerom
make -C roms sgabios
%endif

%check
make check V=1

%install
make install DESTDIR=$RPM_BUILD_ROOT
rm -fr $RPM_BUILD_ROOT/%_datadir/doc
rm -f $RPM_BUILD_ROOT/%_libdir/libcacard.a
rm -f $RPM_BUILD_ROOT/%_libdir/libcacard.la
install -D -m 644 %{SOURCE302} $RPM_BUILD_ROOT/%{_sysconfdir}/qemu/bridge.conf
%find_lang %name
%if %{legacy_qemu_kvm}
cat > %{buildroot}%{_bindir}/qemu-kvm << 'EOF'
#!/bin/sh

%ifarch s390x
exec %{_bindir}/qemu-system-s390x -machine accel=kvm "$@"
%else
exec %{_bindir}/qemu-system-x86_64 -machine accel=kvm "$@"
%endif
EOF
chmod 755 %{buildroot}%{_bindir}/qemu-kvm
install -D -m 755 %{SOURCE2} %{buildroot}/usr/share/qemu/qemu-ifup
install -D -m 755 %{SOURCE3} %{buildroot}%{_bindir}/kvm_stat
install -D -m 644 %{SOURCE4} %{buildroot}%{_mandir}/man1/qemu-kvm.1.gz
%endif
%if %{kvm_available}
%if 0%{?suse_version} >= 1230
install -D -m 644 %{SOURCE1} %{buildroot}%{_udevrulesdir}/80-kvm.rules
%else
%ifarch %ix86 x86_64
install -D -m 644 %{SOURCE7} %{buildroot}%{_udevrulesdir}/60-kvm.rules
%else
install -D -m 644 %{SOURCE5} %{buildroot}%{_udevrulesdir}/60-kvm.rules
%endif
%endif
%endif
install -D -p -m 0644 %{SOURCE6} %{buildroot}%{_unitdir}/ksm.service
%fdupes -s $RPM_BUILD_ROOT

%clean
rm -rf ${RPM_BUILD_ROOT}

%pre
%{_bindir}/getent group kvm >/dev/null || %{_sbindir}/groupadd -r kvm 2>/dev/null
%{_bindir}/getent group qemu >/dev/null || %{_sbindir}/groupadd -r qemu 2>/dev/null
%{_bindir}/getent passwd qemu >/dev/null || \
  %{_sbindir}/useradd -r -g qemu -G kvm -d / -s /sbin/nologin \
  -c "qemu user" qemu

%if %{kvm_available}
%post
if [ "$(readlink -f /proc/1/root)" = "/" ]; then
  /sbin/udevadm control --reload-rules  || :
  /sbin/udevadm trigger || :
fi
%endif

%if 0%{?suse_version} >= 1130
%post tools
%set_permissions %_libexecdir/qemu-bridge-helper

%verifyscript tools
%verify_permissions %_libexecdir/qemu-bridge-helper
%endif

%post   -n libcacard0 -p /sbin/ldconfig

%postun -n libcacard0 -p /sbin/ldconfig

%if 0%{?with_systemd}
%pre ksm
%service_add_pre ksm.service

%post ksm
%service_add_post ksm.service

%preun ksm
%service_del_preun ksm.service

%postun ksm
%service_del_postun ksm.service
%endif

%files
%defattr(-, root, root)
%dir %_libdir/%name
%_libdir/%name/block-curl.so
%doc COPYING COPYING.LIB Changelog README VERSION qemu-doc.html qemu-tech.html
%doc %_mandir/man1/qemu.1.gz
%_datadir/%name
%exclude %_datadir/%name/bios.bin
%exclude %_datadir/%name/bios-256k.bin
%exclude %_datadir/%name/acpi-dsdt.aml
%exclude %_datadir/%name/q35-acpi-dsdt.aml
%exclude %_datadir/%name/vgabios.bin
%exclude %_datadir/%name/vgabios-cirrus.bin
%exclude %_datadir/%name/vgabios-qxl.bin
%exclude %_datadir/%name/vgabios-stdvga.bin
%exclude %_datadir/%name/vgabios-vmware.bin
%exclude %_datadir/%name/sgabios.bin
%exclude %_datadir/%name/pxe-e1000.rom
%exclude %_datadir/%name/pxe-eepro100.rom
%exclude %_datadir/%name/pxe-pcnet.rom
%exclude %_datadir/%name/pxe-ne2k_pci.rom
%exclude %_datadir/%name/pxe-rtl8139.rom
%exclude %_datadir/%name/pxe-virtio.rom
%exclude %_datadir/%name/efi-e1000.rom
%exclude %_datadir/%name/efi-eepro100.rom
%exclude %_datadir/%name/efi-pcnet.rom
%exclude %_datadir/%name/efi-ne2k_pci.rom
%exclude %_datadir/%name/efi-rtl8139.rom
%exclude %_datadir/%name/efi-virtio.rom
%exclude %_datadir/%name/kvmvapic.bin
%exclude %_datadir/%name/linuxboot.bin
%exclude %_datadir/%name/multiboot.bin
%exclude %_datadir/%name/ppc_rom.bin
%exclude %_datadir/%name/openbios-ppc
%exclude %_datadir/%name/slof.bin
%exclude %_datadir/%name/spapr-rtas.bin
%exclude %_datadir/%name/bamboo.dtb
%exclude %_datadir/%name/petalogix-ml605.dtb
%exclude %_datadir/%name/s390-zipl.rom
%exclude %_datadir/%name/s390-ccw.img
%exclude %_datadir/%name/palcode-clipper
%exclude %_datadir/%name/openbios-sparc32
%exclude %_datadir/%name/openbios-sparc64
%exclude %_datadir/%name/petalogix-s3adsp1800.dtb
%exclude %_datadir/%name/QEMU,cgthree.bin
%exclude %_datadir/%name/QEMU,tcx.bin
%ifarch %ix86 x86_64 s390x
%exclude %_datadir/%name/qemu-ifup
%endif
%dir %_sysconfdir/%name
%if %{kvm_available}
%if 0%{?suse_version} >= 1230
%{_udevrulesdir}/80-kvm.rules
%else
%{_udevrulesdir}/60-kvm.rules
%endif
%endif

%files x86
%defattr(-, root, root)
%_bindir/qemu-system-i386
%_bindir/qemu-system-x86_64
%_datadir/%name/kvmvapic.bin
%_datadir/%name/linuxboot.bin
%_datadir/%name/multiboot.bin
%config %_sysconfdir/%name/target-x86_64.conf

%files ppc
%defattr(-, root, root)
%_bindir/qemu-system-ppc
%_bindir/qemu-system-ppc64
%_bindir/qemu-system-ppcemb
%_datadir/%name/ppc_rom.bin
%_datadir/%name/openbios-ppc
%_datadir/%name/slof.bin
%_datadir/%name/spapr-rtas.bin
%_datadir/%name/bamboo.dtb
%_datadir/%name/petalogix-ml605.dtb

%files s390
%defattr(-, root, root)
%_bindir/qemu-system-s390x
%_datadir/%name/s390-zipl.rom
%_datadir/%name/s390-ccw.img

%files arm
%defattr(-, root, root)
%_bindir/qemu-system-arm
%_bindir/qemu-system-aarch64

%files extra
%defattr(-, root, root)
%_bindir/qemu-system-alpha
%_bindir/qemu-system-cris
%_bindir/qemu-system-lm32
%_bindir/qemu-system-m68k
%_bindir/qemu-system-microblaze
%_bindir/qemu-system-microblazeel
%_bindir/qemu-system-mips
%_bindir/qemu-system-mipsel
%_bindir/qemu-system-mips64
%_bindir/qemu-system-mips64el
%_bindir/qemu-system-moxie
%_bindir/qemu-system-or32
%_bindir/qemu-system-sh4
%_bindir/qemu-system-sh4eb
%_bindir/qemu-system-sparc
%_bindir/qemu-system-sparc64
%_bindir/qemu-system-unicore32
%_bindir/qemu-system-xtensa
%_bindir/qemu-system-xtensaeb
%_datadir/%name/palcode-clipper
%_datadir/%name/openbios-sparc32
%_datadir/%name/openbios-sparc64
%_datadir/%name/petalogix-s3adsp1800.dtb
%_datadir/%name/QEMU,cgthree.bin
%_datadir/%name/QEMU,tcx.bin

%if %{legacy_qemu_kvm}
%files kvm
%defattr(-,root,root)
%_bindir/qemu-kvm
%_bindir/kvm_stat
%_datadir/qemu/qemu-ifup
%_mandir/man1/qemu-kvm.1.gz
%endif

%files lang -f %name.lang
%defattr(-, root, root)

%files seabios
%defattr(-, root, root)
%_datadir/%name/bios.bin
%_datadir/%name/bios-256k.bin
%_datadir/%name/acpi-dsdt.aml
%_datadir/%name/q35-acpi-dsdt.aml

%files vgabios
%defattr(-, root, root)
%_datadir/%name/vgabios.bin
%_datadir/%name/vgabios-cirrus.bin
%_datadir/%name/vgabios-qxl.bin
%_datadir/%name/vgabios-stdvga.bin
%_datadir/%name/vgabios-vmware.bin

%files sgabios
%defattr(-, root, root)
%_datadir/%name/sgabios.bin

%files ipxe
%defattr(-, root, root)
%_datadir/%name/pxe-e1000.rom
%_datadir/%name/pxe-eepro100.rom
%_datadir/%name/pxe-pcnet.rom
%_datadir/%name/pxe-ne2k_pci.rom
%_datadir/%name/pxe-rtl8139.rom
%_datadir/%name/pxe-virtio.rom
%_datadir/%name/efi-e1000.rom
%_datadir/%name/efi-eepro100.rom
%_datadir/%name/efi-pcnet.rom
%_datadir/%name/efi-ne2k_pci.rom
%_datadir/%name/efi-rtl8139.rom
%_datadir/%name/efi-virtio.rom

%files tools
%defattr(-, root, root)
%doc %_mandir/man1/qemu-img.1.gz
%doc %_mandir/man1/virtfs-proxy-helper.1.gz
%doc %_mandir/man8/qemu-nbd.8.gz
%_bindir/qemu-io
%_bindir/qemu-img
%_bindir/qemu-nbd
%_bindir/virtfs-proxy-helper
%_bindir/vscclient
%verify(not mode) %_libexecdir/qemu-bridge-helper
%dir %_sysconfdir/%name
%config %_sysconfdir/%name/bridge.conf

%files -n libcacard0
%defattr(-, root, root)
%_libdir/libcacard.so.0*

%files -n libcacard-devel
%defattr(-, root, root)
%dir %_includedir/cacard
%_includedir/cacard/*.h
%_libdir/libcacard.so
%_libdir/pkgconfig/libcacard.pc

%files guest-agent
%defattr(-, root, root)
%attr(755,root,kvm) %_bindir/qemu-ga

%if 0%{?with_systemd}
%files ksm
%defattr(-, root, root)
%{_unitdir}/ksm.service
%endif

%changelog
